PGOBLIN_BANG(-f)
#-- Copyright (C) @BABOLO  2007, 2008 http://www.babolo.ru/
#-- All rights reserved.
#--
#-- Redistribution and use in source and binary forms, with or without
#-- modification, are permitted provided that the following conditions
#-- are met:
#-- 1. Redistributions of source code must retain the above copyright
#--    notice, this list of conditions and the following disclaimer.
#-- 2. Redistributions in binary form must reproduce the above copyright
#--    notice, this list of conditions and the following disclaimer in the
#--    documentation and/or other materials provided with the distribution.
#--
#-- THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
#-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#-- ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
#-- FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#-- DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
#-- OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#-- HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#-- LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#-- OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#-- SUCH DAMAGE.
#--
#-- $Id: restore.m4,v 1.4 2009/07/03 14:44:17 babolo Exp $
#--
#-- Invoking: restore DumpDirectory DataBaseName ...
#-- If DataBaseName omited value of PGDATABASE environment used
#-- all parameters transmited to unerlying .../CIPA_N executes
#-- N = 1, 3, 4, 5 for restore

#connect 0001
DBMS
GETARG(,1)
GETENV(,1)
#perform 0001
CREATE TEMP TABLE x(dumpath text, db text);

INSERT INTO x(dumpath, db)
 SELECT a, (SELECT a FROM a WHERE i = 1 AND a REGEXP '^[a-z_][0-9a-z_]*$') FROM a WHERE i = 0
;
UPDATE x SET db = (SELECT e FROM e WHERE n = 'PGDATABASE' LIMIT 1) WHERE db IS NULL;
DELETE FROM x WHERE dumpath IS NULL OR db IS NULL;
#select 2001
SELECT '#error
No dumpath or db name
'WHERE (SELECT COUNT(*) FROM x) <> 1
#eval 02
#connect 0002
pgsql dbname=template1
#select 2001
SELECT 'CREATE DATABASE ', db FROM x
#perform  0202
#close 0002
#select 2001
SELECT 'pgsql dbname=' || db FROM x
#connect 02

#perform 0001
CREATE TEMP TABLE v(modulename text, i int4, j int4);
CREATE TEMP TABLE d(modulename text, dprog text, l int4, j int4);
#select 3001
SELECT dumpath || '/"public"."cipa dep"' FROM x;
#cat 43
#copyin 0041
COPY d
#close 404
#select 3001
SELECT dumpath || '/"public"."cipa ver"' FROM x;
#cat 43
#copyin 0041
COPY v
#close 404 #--   

#job  0000E
local -z
#perform 0001
CREATE TEMP TABLE t(l int4, modulename text);
#copyout 2001
SELECT * FROM(SELECT modulename, dprog FROM d UNION SELECT modulename, modulename FROM v)d
#exec 3020E
/usr/bin/tsort
#getstr 403
#copyin 0041
COPY t FROM stdin
#wait 0000E # --    
#perform 0001
DROP TABLE d;
DROP TABLE v;

STAGE(1)

#perform 0001
CREATE TEMP TABLE f(i integer PRIMARY KEY, f text);
#select 3001
SELECT '
##cat 4
LIBEDIR/' || modulename || '/CIPA_3
##getstr 504
##copyin 0051
COPY f FROM stdin;
##close 405
##select 4001
SELECT ''COPY '' || f || '' FROM '' || quote_literal(dumpath || ''/'' || f) || '';
''FROM x, f
ORDER BY i
##perform 04
##perform 0001
DELETE FROM f
'FROM x, t
#eval 03

STAGE(4, dumpath)
STAGE(5)
