#!/bin/sh
# $Id: cipa.sh,v 1.1 2008/01/20 05:59:04 babolo Exp $
CIPA=`/usr/bin/basename ${0}`
CIPA=${CIPA%.sh}
CIPA_CONF=%%CONFDIR%%/${CIPA}.conf
. ${CIPA_CONF}
export PGUSER=root
pidfile=/var/run/${CIPA}.pid
debuglog=/var/log/${CIPA}.log

case $1 in
start)
    echo -n " ${CIPA}"
    ${test} -e ${debuglog}.0 && ${mv} -f ${debuglog}.0 ${debuglog}.1
    ${test} -e ${debuglog}   && ${mv} -f ${debuglog}   ${debuglog}.0
    ${su} -l root -c "${CIPACIPA}/cipa ${pidfile}" >> ${debuglog} 2>&1 &
    ;;
stop)
    echo -n " ${CIPA}"
    if  ${test} -r ${pidfile}; then
        pidd="`${head} -1 ${pidfile}`"
        if  ${test} -n "${pidd}"; then
            %%PREFIX%%/bin/collkill -qp ${pidd} -k1 /bin/sh -Te ${CIPACIPA}/cipa ${pidfile}
    fi; fi
    ;;
*)
    echo "start or stop"
    exit 1
    ;;
esac
