PGOBLIN_BANG(-f)
--# Copyright (C) @BABOLO  2007, 2008 http://www.babolo.ru/
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: dump.m4,v 1.3 2009/07/03 14:44:17 babolo Exp $
dnl --# 1  - ,    
dnl --# 2   ,  ,   .
dnl --#     ,       PGDATABASE.
dnl --#      pgoblin.
dnl --#        .

#connect 0001
DBMS
GETARG(,1)
GETENV(,1)
#perform 0001
CREATE TEMP TABLE x(dumpath text, db text);
INSERT INTO x(dumpath, db)
 SELECT a, (SELECT a FROM a WHERE i = 1 AND a REGEXP '^[a-z_][0-9a-z_]*$') FROM a WHERE i = 0
;
DELETE FROM x WHERE dumpath IS NULL;
UPDATE x SET db = (SELECT e FROM e WHERE n = 'PGDATABASE' LIMIT 1) WHERE db IS NULL;
CREATE TEMP TABLE t (nsp text, rel text);
#select 2001
SELECT 'pgsql dbname=' || db FROM x
#connect 0202
#perform 0002
CREATE TEMP TABLE t (nsp name, rel name);
INSERT INTO t(nsp, rel)
 SELECT nspname, relname FROM pg_class, pg_namespace
  WHERE pg_class.relnamespace = pg_namespace.oid
    AND nspname <> 'information_schema'
    AND nspname !~ '^pg_'
    AND NOT relisshared
    AND relkind = 'r'
#copyout 2002
COPY t TO stdout
#copyin 0021
COPY t
#perform 0001
ALTER TABLE t ADD p text;
UPDATE t SET p = quote_literal( (SELECT dumpath FROM x) || '/'
                             || quote_ident_always(nsp) || '.' || quote_ident_always(rel)
                              )
#copyout 2001
COPY t
#perform 0002
ALTER TABLE t ADD p text;
#copyin 0022
COPY t FROM stdin
#select 3002
SELECT 'COPY ' || quote_ident(nsp) || '.' || quote_ident(rel) || ' TO ' || p || ';
'FROM t
;
#perform 0302
