PGOBLIN_BANG(-f)
#-- Copyright (C) @BABOLO  2007, 2008 http://www.babolo.ru/
#-- All rights reserved.
#--
#-- Redistribution and use in source and binary forms, with or without
#-- modification, are permitted provided that the following conditions
#-- are met:
#-- 1. Redistributions of source code must retain the above copyright
#--    notice, this list of conditions and the following disclaimer.
#-- 2. Redistributions in binary form must reproduce the above copyright
#--    notice, this list of conditions and the following disclaimer in the
#--    documentation and/or other materials provided with the distribution.
#--
#-- THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
#-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#-- ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
#-- FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#-- DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
#-- OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#-- HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#-- LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#-- OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#-- SUCH DAMAGE.
#--
#-- $Id: init.m4,v 1.1 2009/07/03 14:44:17 babolo Exp $
#--
#-- Invoking: init modulename DataBaseName ...
#-- If DataBaseName omited value of PGDATABASE environment used
#-- all parameters transmited to unerlying .../CIPA_N executes
#-- N = 1, 2, 5 for init

#connect 0001
DBMS
GETARG(,1)
GETENV(,1)
#perform 0001
CREATE TEMP TABLE x(modulename text, db text);

INSERT INTO x(modulename, db)
 SELECT a, (SELECT a FROM a WHERE i = 1 AND a REGEXP '^[a-z_][0-9a-z_]*$') FROM a WHERE i = 0
;
UPDATE x SET db = (SELECT e FROM e WHERE n = 'PGDATABASE' LIMIT 1) WHERE db IS NULL;
DELETE FROM x WHERE modulename IS NULL OR db IS NULL;
#select 2001
SELECT '#error
No modulename or db name
'WHERE (SELECT COUNT(*) FROM x) <> 1
#eval 02
#select 2001
SELECT 'pgsql dbname=' || db FROM x
#connect 02

DIRECTSTAGE(1)
DIRECTSTAGE(2)
DIRECTSTAGE(5)
